#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "assign_template") {&assign_template;}

##################################################################################

sub assign_template
{

$cid = $q->param('cid');

$curr_tmpl = $q->param('template_in_use');

if ($curr_tmpl eq "default")
	{
	$curr_tmpl = "";
	}

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
 


if ($q->param('subcats') eq "Y")
	{
	$ct = $q->param('ct');
	$ct = substr($ct, 0, length($ct) - 1);
	@dcats = split(/\//, $ct);
	
		$lvc = 1;
		foreach $item(@dcats)
			{
			$item =~ s/'/\\'/g; 
			$fieldname = "l" . $lvc;
			$where_sql = $where_sql . " ($fieldname = '$item') AND";
			$lvc++;
			}
	
	$where_sql = substr($where_sql, 0, length($where_sql) - 3);
	
	$sql = "UPDATE dirs SET template = '$curr_tmpl' WHERE $where_sql";	
	}
	else
	{
	$sql = "UPDATE dirs SET template = '$curr_tmpl' WHERE cid = '$cid'";
	}


$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
 
$sth->finish;
$dbh->disconnect;



$hbox = acs::get_heading_box("$web_url/ic_banner.gif", "Assign a Custom Template To Category/Directory", qq[<p>The template you have chosen for this category/directory has been set.</p>
<p><strong>You may now <a href="javascript:onClick=window.close()">close</a> this window.</strong></p>]);



print <<END_OF_ST;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body onUnload="opener.location.reload(true);">

$hbox

</body>
</html>

END_OF_ST

}





sub start
{

$cid = $q->param('cid');

### GET LOCATION AND CURRENT TEMPLATE IN USE

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
 
$sql = "SELECT * FROM dirs WHERE cid = '$cid'";

$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

while ( @row = $sth->fetchrow() )
	{
	$cats = "";
	for ($ms = 2; $ms < 18; $ms++) 
		{
		if ($row[$ms] ne "")
			{
			$cats = $cats . $row[$ms] . "/";
			}
		} 
	
	if ($row[27] ne "")
		{
		$template_sel = "$row[27]";
		}
	}
	
$sth->finish;
$dbh->disconnect;

$current_cat = $cats;

if ($template_sel eq ""){$dfs = "selected";}
$sel_option_name = "<option $dfs value=\"default\">Default</option>";

opendir(DIR,"$data_dir");
	@files = readdir(DIR);
	@files = sort(@files);
	foreach $filename (@files)
		{
		if (substr($filename, length($filename) - 11, 11) eq "-1ctst\.html")
			{
			$ct_name = substr($filename, 0, length($filename) - 11); 
			
			$ct_sel = "";
			if ($ct_name eq $template_sel)
				{
				$ct_sel = "selected";
				}
			$sel_option_name = $sel_option_name . "<option $ct_sel value=\"$ct_name\">$ct_name</option>";
 			}
 		}
closedir(DIR);

$hbox = acs::get_heading_box("$web_url/ic_banner.gif", "Assign a Custom Template To Category/Directory", qq[Choose a 'custom Category/Directory' template set to be used for this category/directory below.]);


$helpb = acs::quick_help("Quick Help",qq[
You can create custom category/directory template sets by going to the 'Dir Manager' tab >> 1. Default Category/Directory Templates >> Create or Edit Custom Category/Directory Template Sets
]);  


print <<END_OF_EM;
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>

$hbox




<form method="POST" action="$admin_url/admin28.cgi">
  <table border="0"
  cellpadding="6" width="100%" style="border: 1px solid rgb(218,218,218)" cellspacing="1">
    <tr>
      <td width="101%"
      height="30" colspan="2" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Assign the use of a template to:</strong></td>
    </tr>
    <tr>
      <td width="101%" colspan="2" valign="top" bgcolor="#FFFFFF" class="normaltext"><font color="#0000FF"><b>$current_cat</b></font></span></td>
    </tr>
    <tr>
      <td width="15%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Template:</strong></td>
      <td width="86%" valign="top" bgcolor="#FFFFFF" class="normaltext"><select name="template_in_use" size="1">
      $sel_option_name</select> </td>
    </tr>
    <tr>
      <td width="15%" valign="top" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="86%" valign="top" bgcolor="#FFFFFF" class="normaltext"><input type="checkbox" name="subcats"
      value="Y">Assign this template to all sub categories/directories of this
      category/directory. </td>
    </tr>
    <tr>
      <td width="15%" valign="top" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="86%" valign="top" bgcolor="#FFFFFF" class="normaltext"><input type="submit"
      value="Assign Template" name="B1">
      <input type="hidden" name="ct" value="$cats">
      <input type="hidden" name="cid"
  value="$cid">
      <input type="hidden" name="fct" value="assign_template"></td>
    </tr>
  </table>

<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>

$helpb

</form>



</body>
</html>

END_OF_EM

}


####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

